#include <vector>
#include <complex>
#include <iostream>
#include <algorithm>

using namespace std;

const double pi=3.14159265358979323;
typedef complex<double> CD;
typedef vector<CD> VCD;
typedef VCD::iterator VCDI;
typedef VCD::const_iterator VCDCI;

double fabs(const CD &r) {return sqrt(norm(r));}
ostream& operator<<(ostream& os,VCD &r)
{
	for(VCDCI it=r.begin();it!=r.end();++it)
	{
		double t=fabs(*it);
		os<<(t>1e-6?t:0)<<" ";
	}
	return os<<endl;
}

void Fourie(VCD &vv1,int sign=1,bool norm=true)
{
	VCD vv2(vv1.size());
	VCD *p1=&vv1,*p2=&vv2;
	int n=int(vv1.size()),m=1;
	int n1,m1;
	while(n>1)
	{
		int d;int sq=int(sqrt(double(n)));
		if(n%2==0) d=2; else {d=3;while(d<=sq&&(n%d!=0)) d+=2;if(d>sq) d=n;}
		m1=m*d;n1=n/d;
		VCD &v1=*p1,&v2=*p2;
		for(int k=0;k<m1;k++)
			for(int l=0;l<n1;l++)
			{
				v2[k*n1+l]=0;
				for(int t=0;t<d;t++)
					v2[k*n1+l]+=v1[n*(k%m)+l+t*n1]*exp(CD(0,sign*pi*2/m1*t*k));
			}		
		m=m1;n=n1;
		VCD *temp=p1;p1=p2;p2=temp;
	}	
	vv1=*p1;
	if (norm)
		for(int i=0;i<int(vv1.size());i++) vv1[i]/=sqrt(double(vv1.size()));
}

void convolve(VCD &r)
{
	Fourie(r);
	for(VCDI it=r.begin();it!=r.end();++it)
		(*it)=norm(*it);
	Fourie(r,-1,false);
}

void straiConvolve(VCD &r)
{
	VCD tmp;
	int a,b;
	int N=int(r.size());
	for(a=0;a<N;++a)
	{
		CD s;
        for(b=0;b<N;++b)
			s+=r[b]*r[((a+b)%N+N)%N];
		tmp.push_back(s);
	}
	r.swap(tmp);
}

void main()
{
	VCD ar(20),ar1;
	for(int t=0;t<3;++t)
		ar[t+4]=1+t;
	ar1=ar;
	cout<<ar;
	convolve(ar);cout<<ar;
	straiConvolve(ar1);cout<<ar1;
}
